###############################################################################################
# Exemplo de programa em linguagem de montagem do MIPS : Manipulando vetores
# Autor: Ney Calazans
# Funo: Este programa soma o valor de uma constante (const) a cada elemento do vetor array
###############################################################################################
        
        .text                   # Diretiva para o montador - adiciona o que vem abaixo
        			# 	 memria de programa do processador
        .globl  main            # Declare o rtulo main Como sendo global
        			#  o ponto a partir de onde se inicia a execuo
main:
        la      $t0,array       # o registrador $t0 contm o endereo do vetor
        la      $t1,size        # obtm o endereo da posio da memria de dados onde se guarda
        			# o tamanho do vetor
        lw      $t1,0($t1)      # o registrador $t1 contm o tamanho do vetor
        la      $t2,const       # obtm o endereo da constante const
        lw      $t2,0($t2)      # o registrador $t2 contm a constante a somar
loop:   blez    $t1,end         # se o tamanho chega a 0, fim do processamento
        lw      $t3,0($t0)      # obtm um elemento do vetor
        addu    $t3,$t3,$t2     # soma a constante
        sw      $t3,0($t0)      # atualiza o vetor
        addiu   $t0,$t0,4       # atualiza o apontadoe do vetor
        			# lembrar que 1 palavra no MIPS ocupa 4 endereos consecutivos de memria
        addiu   $t1,$t1,-1      # decrementa o contador de tamanho do vetor
        j       loop            # continua a execuo
        
        # Agora volta para o programa monitor
end:    j       $ra

        .data                   # Diretiva para o montador - adiciona o que vem abaixo
        			# 	 memria de dados do processador
array:  .word   0x12 0xff 0x3 0x14 0x878 0x31  0x62 0x10 0x5 0x16 0x20 # o vetor
                                # A diretiva ,.word carrega a lista de inteiros em posies successivas
                                # 	da memria de dados
size:   .word   11              # Varivel que armazena o tamanho do vetor
const:  .word   0x100           # Constante a somar a cada elemento do vetor
